"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const add_record_1 = require("../records/add.record");
const db_1 = require("../utils/db");
afterAll(() => __awaiter(void 0, void 0, void 0, function* () {
    yield db_1.pool.end();
}));
const defaultObj = {
    name: "Test",
    description: "blah",
    url: "https://testowy.com",
    price: 4,
    lat: 9,
    lon: 9,
};
test("AdRecord returns data from database", () => __awaiter(void 0, void 0, void 0, function* () {
    const ad = yield add_record_1.AddRecord.getOne("abc");
    expect(ad).toBeDefined();
    expect(ad.id).toBe("abc");
    expect(ad.description).toBe("testowaaaa");
}));
test("AdRecord returns null from databse for unexciting entry", () => __awaiter(void 0, void 0, void 0, function* () {
    const ad = yield add_record_1.AddRecord.getOne("----");
    expect(ad).toBeNull();
}));
test("AdRecord returns array of found entries", () => __awaiter(void 0, void 0, void 0, function* () {
    const ads = yield add_record_1.AddRecord.findAll("");
    expect(ads).not.toEqual([]);
    expect(ads[0].id).toBeDefined();
}));
test("AdRecord returns empty array when searching for sth that does not exist", () => __awaiter(void 0, void 0, void 0, function* () {
    const ads = yield add_record_1.AddRecord.findAll("-----------------");
    expect(ads).toEqual([]);
}));
test("AdRecord returns small data", () => __awaiter(void 0, void 0, void 0, function* () {
    const ads = yield add_record_1.AddRecord.findAll("");
    expect(ads[0].price).toBeUndefined();
    expect(ads[0].description).toBeUndefined();
}));
test("AdRecord inserts  returns uuid", () => __awaiter(void 0, void 0, void 0, function* () {
    const ad = new add_record_1.AddRecord(defaultObj);
    yield ad.insert();
    expect(ad.id).toBeDefined();
    expect(typeof ad.id).toBe("string");
}));
test("AdRecord inserts data to database", () => __awaiter(void 0, void 0, void 0, function* () {
    const ad = new add_record_1.AddRecord(defaultObj);
    yield ad.insert();
    const foundAd = yield add_record_1.AddRecord.getOne(ad.id);
    expect(foundAd).toBeDefined();
    expect(foundAd).not.toBeNull();
    expect(foundAd.id).toBe(ad.id);
}));
//# sourceMappingURL=ads.test.js.map